只记录安装步骤,不对细节做过多说明。

   



一、httpd与php的结合方式

   (1)把php编译为httpd的第三方模块

       优点:避免了了httpd与php之间的通信。

       缺点:层次架构不清晰,性能表现上不算优良。

       注意:如果httpd使用prefork MPM,则php需要编译为libphp5.so模块;如果httpd使用event或workerMPM,则php需要编译为zts模块。(--enable-maintainer-zts)

  (2)CGI

       一般不作为php跟httpd的结合方式。

   (3)FastCGI

      把php工作为守护进程,需要fpm组件(php-5.3.3之后的版本都自带了此模块),监听在9000端口。


二、安装httpd2.4.12

    安装前准备

   首先得为系统安装“Development tools”和“Server Platform Development”两个包组。

    apr是什么?

    apr,即apache portable runtime,httpd的运行时环境,可以理解为httpd的虚拟机。

    httpd2.4依赖1.4版本以上的apr,在此,我们使用编译安装的方法来安装apr和apr-util。

./configure --prefix=/usr/local/apr
./configure --prefix=/usr/local/apr-util --with-apr=/usr/local/apr


    如果在编译的时候使用参数--with-pcre,则还需要提供pcre和pcre-util程序。


--sysconfdir=/etc/httpd 指明配置文件存放路径
--enable-so   支持DSO(模块动态装卸载)机制
--with-zlib   支持文件在传输时使用压缩格式,使用此选项有可能需要手动安装zlib-devel程序
--enable-modules-share=most  
--enable-mpms-shared=all  所安装的httpd可以使用prefork,work和event MPM
--with-mpm=prefork   默认使用的MPM为prefork

./configure --prefix=/usr/local/apache --sysconfdir=/etc/httpd --enable-so --enable-ssl --enable-cgi --enable-rewrite --with-zlib --with-pcre --with-apr=/usr/local/apr --with-apr-util=/usr/local/apr-util --enable-modules=most --enable-mpms-shared=all --with-mpm=prefork

 make

 make install

/usr/local/apache/bin/apachectl start

  然后使用浏览器 访问,测试正常。

 编译方式搭建LAMP_9000


提供SysV服务脚本/etc/rc.d/init.d/httpd,内容如下:


#!/bin/bash

#

# httpd        Startup script for the Apache HTTP Server

#

# chkconfig: - 85 15

# description: Apache is a World Wide Web server.  It is used to serve \

#        HTML files and CGI.

# processname: httpd

# config: /etc/httpd/conf/httpd.conf

# config: /etc/sysconfig/httpd

# pidfile: /usr/local/apache/logs/httpd.pid


# Source function library.

. /etc/rc.d/init.d/functions


if [ -f /etc/sysconfig/httpd ]; then

        . /etc/sysconfig/httpd

fi


# Start httpd in the C locale by default.

HTTPD_LANG=${HTTPD_LANG-"C"}


# This will prevent initlog from swallowing up a pass-phrase prompt if

# mod_ssl needs a pass-phrase from the user.

INITLOG_ARGS=""


# Set HTTPD=/usr/sbin/httpd.worker in /etc/sysconfig/httpd to use a server

# with the thread-based "worker" MPM; BE WARNED that some modules may not

# work correctly with a thread-based MPM; notably PHP will refuse to start.


# Path to the apachectl script, server binary, and short-form for messages.

apachectl=/usr/local/apache/bin/apachectl

httpd=${HTTPD-/usr/local/apache/bin/httpd}

prog=httpd

pidfile=${PIDFILE-/usr/local/apache/logs/httpd.pid}

lockfile=${LOCKFILE-/var/lock/subsys/httpd}

RETVAL=0


start() {

        echo -n $"Starting $prog: "

        LANG=$HTTPD_LANG daemon --pidfile=${pidfile} $httpd $OPTIONS

        RETVAL=$?

        echo

        [ $RETVAL = 0 ] && touch ${lockfile}

        return $RETVAL

}


stop() {

  echo -n $"Stopping $prog: "

  killproc -p ${pidfile} -d 10 $httpd

  RETVAL=$?

  echo

  [ $RETVAL = 0 ] && rm -f ${lockfile} ${pidfile}

}

reload() {

    echo -n $"Reloading $prog: "

    if ! LANG=$HTTPD_LANG $httpd $OPTIONS -t >&/dev/null; then

        RETVAL=$?

        echo $"not reloading due to configuration syntax error"

        failure $"not reloading $httpd due to configuration syntax error"

    else

        killproc -p ${pidfile} $httpd -HUP

        RETVAL=$?

    fi

    echo

}


# See how we were called.

case "$1" in

  start)

  start

  ;;

  stop)

  stop

  ;;

  status)

        status -p ${pidfile} $httpd

  RETVAL=$?

  ;;

  restart)

  stop

  start

  ;;

  condrestart)

  if [ -f ${pidfile} ] ; then

    stop

    start

  fi

  ;;

  reload)

        reload

  ;;

  graceful|help|configtest|fullstatus)

  $apachectl $@

  RETVAL=$?

  ;;

  *)

  echo $"Usage: $prog {start|stop|restart|condrestart|reload|status|fullstatus|graceful|help|configtest}"

  exit 1

esac


exit $RETVAL


而后为此脚本赋予执行权限:

# chmod +x /etc/rc.d/init.d/httpd


加入服务列表:

# chkconfig --add httpd


三、安装mariadb-5.5.43

  使用二进制格式的mariadb程序包。

 1,创建目录,/mydata/data作为mariadb的数据存放目录。

 2,新建用户以安全方式运行进程:

     groupadd -r mysql

     useradd -g mysql -r -s /sbin/nologin -M -d /mydata/data mysql

     chown -R mysql:mysql /mydata/data

 

 3,安装并初始化

   tar xf mariadb-5.5.43-linux-x86_64.tar.gz -C /usr/local

   cd /usr/local/

   ln -sv mariadb-5.5.43-linux-x86_64  mysql

   cd mysql 


   chown -R mysql:mysql  .

   scripts/mysql_install_db --user=mysql --datadir=/mydata/data

   chown -R root  .

 4,为mysql提供配置文件:

   cd /usr/local/mysql

   cp support-files/my-large.cnf  /etc/my.cnf

   并修改此文件中thread_concurrency的值为你的CPU个数乘以2,比如这里使用如下行:

   thread_concurrency = 2

   另外还需要添加如下行指定mysql数据文件的存放位置:

   datadir = /mydata/data(需要在[mysqld]字段添加)


  5、为mysql提供sysv服务脚本:

    cd /usr/local/mysql

    cp support-files/mysql.server  /etc/rc.d/init.d/mysqld

    chmod +x /etc/rc.d/init.d/mysqld


  添加至服务列表:

    chkconfig --add mysqld

    chkconfig mysqld on


 6,修改PATH环境变量,让系统可以直接使用mysql的相关命令。

   vim /etc/profile.d/mysqld.sh

   export PATH=$PATH:/usr/local/mysql/bin

   . /etc/profile.d/mysqld.sh


四、安装php

   编译php成为httpd的第三方模块

./configure --prefix=/usr/local/php --with-mysql --with-openssl --with-mysqli --enable-mbstring --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml --enable-sockets --with-apxs2=/usr/local/apache/bin/apxs --with-mcrypt --with-config-file-path=/etc --with-config-file-scan-dir=/etc/php.d --with-bz2

为php提供配置文件:

# cp php.ini-production /etc/php.ini


编辑apache配置文件httpd.conf,以apache支持php

# vim /etc/httpd/httpd.conf

 1、添加如下二行

   AddType application/x-httpd-php  .php

   AddType application/x-httpd-php-source  .phps


 2、定位至DirectoryIndex index.html 

   修改为:

    DirectoryIndex  index.php  index.html


 在安装了mysql的主机上对httpd服务器授权

编译方式搭建LAMP_通信_02编写测试页面,测试php可正常使用

测试页面index.php示例如下:

    <?php

      $link = mysql_connect('172.16.249.18','nxp','hank');

      if ($link)

        echo "Success...";

      else

        echo "Failure...";


      mysql_close();

    ?>